Attribute VB_Name = "modWinSockLib"
Option Explicit

'Winsock DLL imports
Public Declare Function bind Lib "wsock32.dll" (ByVal S As Long, addr As sockaddrTYPES, ByVal namelen As Long) As Long
Public Declare Function closesocket Lib "wsock32.dll" (ByVal S As Long) As Long
Public Declare Function ntohs Lib "wsock32.dll" (ByVal netshort As Long) As Integer
Public Declare Function htons Lib "wsock32.dll" (ByVal hostshort As Long) As Integer
Public Declare Function inet_addr Lib "wsock32.dll" (ByVal CP As String) As Long
Public Declare Function recvfrom Lib "wsock32.dll" (ByVal S As Long, buf As Any, ByVal buflen As Long, ByVal Flags As Long, From As sockaddrTYPES, fromlen As Long) As Long
Public Declare Function sendto Lib "wsock32.dll" (ByVal S As Long, buf As Any, ByVal buflen As Long, ByVal Flags As Long, to_addr As sockaddrTYPES, ByVal tolen As Long) As Long
Public Declare Function socket Lib "wsock32.dll" (ByVal af As Long, ByVal s_type As Long, ByVal protocol As Long) As Long
Public Declare Function gethostbyname Lib "wsock32.dll" (ByVal host_name As String) As Long
Public Declare Function WSAStartup Lib "wsock32.dll" (ByVal wVR As Long, lpWSAD As WSAdataTYPES) As Long
Public Declare Function WSACleanup Lib "wsock32.dll" () As Long
Public Declare Function WSAAsyncSelect Lib "wsock32.dll" (ByVal S As Long, ByVal hwnd As Long, ByVal wMsg As Long, ByVal lEvent As Long) As Long

Public Enum FD
 FD_READ = 1
 FD_WRITE = 2
 FD_OOB = 4
 FD_ACCEPT = 8
 FD_CONNECT = 16
 FD_CLOSE = 32
 FD_SETSIZE = 64
End Enum
Public Const FD_ALL = 1 Or 2 Or 4 Or 8 Or 16 Or 32 Or 64

Public Type hostentTYPES
 h_name As Long
 h_aliases As Long
 h_addrtype As Integer
 h_length As Integer
 h_addr_list As Long
End Type
Public hostent As hostentTYPES

Public Type WSAdataTYPES
 wVersion As Integer
 wHighVersion As Integer
 szDescription As String * 257
 szSystemStatus As String * 129
 iMaxSockets As Integer
 iMaxUdpDg As Integer
 lpVendorInfo As Long
End Type
Public WSAdata As WSAdataTYPES

Public Type sockaddrTYPES
 sin_family As Integer 'bot uses 2 (udp connection)
 sin_port As Integer 'used with bot
 sin_addr As Long 'used with bot
 sin_zero As String * 8 'don't know
End Type

'Winsock window handle
Public WinsockWindow As Long 'Handle of window that captures Winsock Stack
Public OldWinsockWindow As Long

'Winsock utilities
Function Long2IP(Address As Long) As String
Dim S4 As String * 4
S4 = GetStringL(Address)
Long2IP = CStr(Asc(Left(S4, 1))) + "." + CStr(Asc(Mid(S4, 2, 1))) + "." + CStr(Asc(Mid(S4, 3, 1))) + "." + CStr(Asc(Right(S4, 1)))
End Function

Function IP2Long(ByVal Hostname As String) As Long
Dim L As Long, addrList As Long, retIP As Long

retIP = inet_addr(Hostname)
If retIP = &HFFFF Then
 L = gethostbyname(Hostname)
 If L <> 0 Then
  RtlMoveMemory hostent, L, 16
  RtlMoveMemory addrList, hostent.h_addr_list, 4
  RtlMoveMemory retIP, addrList, hostent.h_length
 Else
  retIP = &HFFFF
 End If
End If

IP2Long = retIP
End Function

'Init/Destroy
Sub StartWinsock()
WSAStartup 257&, WSAdata
If Err.LastDllError > 0 Then AddTerminal 0, "WSAStartup() error: " + GetWinsockError(Err.LastDllError), 12

'WinsockWindow = CreateWindowExA(0, "#32770", app.title & " - Winsock Stack Capture", 0&, 0, 0, 1, 1, 0&, 0&, App.hInstance, 0&)
WinsockWindow = frmTerminal.hwnd 'Use our frmTerminal window instead
'If Err.LastDllError > 0 Then AddTerminal 0, "CreateWindowExA() error: " + CStr(Err.LastDllError), 12

OldWinsockWindow = SetWindowLongA(WinsockWindow, -4, AddressOf WindowProc) 'start scanning winsock stack in WindowProc function
If Err.LastDllError > 0 Then AddTerminal 0, "SetWindowLongA() error: " + CStr(Err.LastDllError), 12
End Sub

Sub EndWinsock()
SetWindowLongA WinsockWindow, -4, OldWinsockWindow 'exit our winsock stack catching WindowProc function (isn't needed when terminating and using our own window, but needed when unloading last bot to prevent crashes)
'DestroyWindow WinsockWindow 'no need to destroy if using our own window
WSACleanup
End Sub

'Packet backlog
Sub ClearACKs(BotIndex As Byte)
Dim L As Long
For L = -32768 To 32767
 ACKs(BotIndex, L) = 0
Next
End Sub

'Sub ClearBacklog(BotIndex As Byte)
'Dim I As Integer
'For I = 1 To LastBacklog
' Backlog(BotIndex, I).Closed = 0
'Next
'LastBacklog = 0
'End Sub

'Function GetNext(LoopEntry As Integer) As Integer
'If LoopEntry = 32767 Then
' GetNext = -32768
'Else
' GetNext = LoopEntry + 1
'End If
'End Function

'Sub CheckBacklog(BotIndex As Byte, DecryptedPacket As String, PacketID As Integer)
'On Error GoTo FlyPaper
'Dim I As Integer, I2 As Integer
'If PacketID = GetNext(Bots(BotIndex).LastPacketID) Then
' 'Handle this one
' Bots(BotIndex).LastPacketID = PacketID
' HandleGamePacket BotIndex, Mid(DecryptedPacket, 7)
' 'Check the backlog for queued entries
'rescan:
' For I = 1 To LastBacklog
'  If Backlog(BotIndex, I).Closed Then
'   If Backlog(BotIndex, I).PacketID = GetNext(Bots(BotIndex).LastPacketID) Then
'    HandleGamePacket BotIndex, Backlog(BotIndex, I).Data
'    Backlog(BotIndex, I).Closed = 0
'    Bots(BotIndex).LastPacketID = Backlog(BotIndex, I).PacketID
'    LastBacklog = 0
'    For I2 = I To 1 Step -1
'     If Backlog(BotIndex, I2).Closed Then LastBacklog = I2: Exit For
'    Next
'    GoTo rescan
'   End If
'  End If
' Next
'Else
' 'Queue this message, wait for the next one in sequence
' For I = 1 To MAX_BACKLOG
'  If Backlog(BotIndex, I).Closed = 0 Then
'   Backlog(BotIndex, I).PacketID = PacketID
'   Backlog(BotIndex, I).Data = Mid(DecryptedPacket, 7)
'   Backlog(BotIndex, I).Closed = 1
'   If I > LastBacklog Then LastBacklog = I
'   Exit Sub
'  End If
' Next
'' 'If it gets to this point, just flush the backlog and handle everything
'' For I = 1 To MAX_BACKLOG
''  HandleGamePacket BotIndex, Backlog(BotIndex, I).Data
''  Backlog(BotIndex, I).Closed = 0
'' Next
'' LastBacklog = 0
'' HandleGamePacket BotIndex, Mid(DecryptedPacket, 7)
'End If
'Exit Sub

'FlyPaper:
'AddTerminal BotIndex, "Error detected in CheckBacklog(" + CStr(PacketID) + "): " + Err.Description, 12
'End Sub

'Secure socket language. These are just types of counted messages sent. "Secures" for short
'Sub AddSecure(BotIndex As Byte, Message As String)
'Dim b As Byte
'For b = 1 To MAX_SECURES
' If Secures(b).ResendCount = 0 Then
'  Secures(b).InitialTicks = GetTickCount
'  Secures(b).Message = Message
'  Secures(b).ResendCount = 1
'  Secures(b).BotFrom = BotIndex
'  Exit Sub
' End If
'Next
'End Sub

'Sub ResendSecures()
'Dim b As Byte
'For b = 1 To MAX_SECURES
' If Secures(b).ResendCount > 0 Then
'  UDPSend Secures(b).BotFrom, Secures(b).Message, False
'  Secures(b).InitialTicks = GetTickCount
'  Secures(b).ResendCount = Secures(b).ResendCount + 1
'  If Secures(b).ResendCount > 10 Then Secures(b).ResendCount = 0
' End If
'Next
'End Sub

'Sub ClearSecures(BotIndex As Byte)
'Dim b As Byte
'For b = 1 To MAX_SECURES
' If Secures(b).BotFrom = BotIndex Then Secures(b).ResendCount = 0
'Next
'End Sub

'Queued chat messages
'Sub AddQueue(BotIndex As Byte, Message As String)
'Dim I As Integer
'If Bots(BotIndex).UseQueue = 0 Or Bots(BotIndex).HasSysop Then
' UDPSend BotIndex, Message, True
' Bots(BotIndex).UseQueue = 1
'Else
' For I = 1 To MAX_QUEUED
'  If Bots(BotIndex).QueuedMessages(I) = "" Then Bots(BotIndex).QueuedMessages(I) = Message: Exit Sub
' Next
'End If
'End Sub

''Lag stats
'Sub UpdateLag(BotIndex As Byte, NewValue As Long)
'Dim L As Long

'With Bots(BotIndex)
'If .AvgPing = 0 Then .AvgPing = NewValue: .PingTime = NewValue

''Filter spikes
'If NewValue > .AvgPing * 2 Then Exit Sub

''Use (lag interval) * 2 for the tmrSecures timer
''on error Resume Next
''frmTerminal.tmrSecures.Interval = .PingTime + NewValue
''frmTerminal.tmrSecures.Enabled = 0
''frmTerminal.tmrSecures.Enabled = 1
''.PingTime = frmTerminal.tmrSecures.Interval \ 2
'.PingTime = (.PingTime + NewValue) \ 2

''Update the average ping time
'on error GoTo TooBig
'L = .AvgPing * .TotalPings + .PingTime
'.AvgPing = Int(CInt(L) \ (.TotalPings + 1))
'.TotalPings = .TotalPings + 1
'Exit Sub

'TooBig:
'.AvgPing = .PingTime
'.TotalPings = 1
'End With
'End Sub

Sub UDPSend(BotIndex As Byte, Message As String, SendSecure As Boolean)
If SendSecure Then
 Message = Chr(0) + Chr(3) + GetStringL(Bots(BotIndex).TotalSecuresSent) + Message
 Bots(BotIndex).TotalSecuresSent = Bots(BotIndex).TotalSecuresSent + 1 'needed
' AddSecure BotIndex, Message
End If

If Left(Message, 2) <> Chr(0) + Chr(1) Then Encrypt BotIndex, Message
'''If Left(Message, 2) <> Chr(0) + Chr(1) Then
'''' Message = Cipher(Bots(BotIndex).SSEncrKey, Message)
''' If Bots(BotIndex).SSEncrKey > 0 Then
''''  Message = pwEncryption(Message)
''''  Message = Cipher(Bots(BotIndex).SSEncrKey, Message)
'''  If Left(Message, 1) = Chr(0) Then
''''   'SSEncrypt Bots(BotID).SSEncrTable, packet, 3
''''   Message = Left(Message, 2) & Cipher(Bots(BotIndex).SSEncrKey, Mid(Message, 3))
''''   Message = Left(Message, 2) & SHL(Mid(Message, 3))
'''   Message = Left(Message, 2) & pwEncryption(Mid(Message, 3))
'''  Else
''''   'SSEncrypt Bots(BotID).SSEncrTable, packet, 2
''''   Message = Left(Message, 1) & Cipher(Bots(BotIndex).SSEncrKey, Mid(Message, 2))
''''   Message = Left(Message, 1) & SHL(Mid(Message, 2))
'''   Message = Left(Message, 1) & pwEncryption(Mid(Message, 2))
'''  End If
''' End If
'''End If

sendto Bots(BotIndex).SockID, ByVal Message, Len(Message), 0, Bots(BotIndex).Sock, 16&

Bots(BotIndex).TotalSent = Bots(BotIndex).TotalSent + 1
End Sub

Function GetWinsockError(ErrorNumber As Integer) As String
Select Case ErrorNumber
Case 10004: GetWinsockError = "Interrupted system call."
Case 10009: GetWinsockError = "Bad file number."
Case 10013: GetWinsockError = "Permission Denied."
Case 10014: GetWinsockError = "Bad Address."
Case 10022: GetWinsockError = "Invalid Argument."
Case 10024: GetWinsockError = "Too many open files."
Case 10035: GetWinsockError = "Operation would block."
Case 10036: GetWinsockError = "Operation now in progress."
Case 10037: GetWinsockError = "Operation already in progress."
Case 10038: GetWinsockError = "Socket operation on nonsocket."
Case 10039: GetWinsockError = "Destination address required."
Case 10040: GetWinsockError = "Message too long."
Case 10041: GetWinsockError = "Protocol wrong type for socket."
Case 10042: GetWinsockError = "Protocol not available."
Case 10043: GetWinsockError = "Protocol not supported."
Case 10044: GetWinsockError = "Socket type not supported."
Case 10045: GetWinsockError = "Operation not supported on socket."
Case 10046: GetWinsockError = "Protocol family not supported."
Case 10047: GetWinsockError = "Address family not supported by protocol family."
Case 10048: GetWinsockError = "Address already in use."
Case 10049: GetWinsockError = "Can't assign requested address."
Case 10050: GetWinsockError = "Network is down."
Case 10051: GetWinsockError = "Network is unreachable."
Case 10052: GetWinsockError = "Network dropped connection."
Case 10053: GetWinsockError = "Software caused connection abort."
Case 10054: GetWinsockError = "Connection reset by peer."
Case 10055: GetWinsockError = "No buffer space available."
Case 10056: GetWinsockError = "Socket is already connected."
Case 10057: GetWinsockError = "Socket is not connected."
Case 10058: GetWinsockError = "Can't send after socket shutdown."
Case 10059: GetWinsockError = "Too many references: can't splice."
Case 10060: GetWinsockError = "Connection timed out."
Case 10061: GetWinsockError = "Connection refused."
Case 10062: GetWinsockError = "Too many levels of symbolic links."
Case 10063: GetWinsockError = "File name too long."
Case 10064: GetWinsockError = "Host is down."
Case 10065: GetWinsockError = "No route to host."
Case 10066: GetWinsockError = "Directory not empty."
Case 10067: GetWinsockError = "Too many processes."
Case 10068: GetWinsockError = "Too many users."
Case 10069: GetWinsockError = "Disk quota exceeded."
Case 10070: GetWinsockError = "Stale NFS file handle."
Case 10071: GetWinsockError = "Too many levels of remote in path."
Case 10091: GetWinsockError = "Network subsystem is unusable."
Case 10092: GetWinsockError = "Winsock DLL cannot support this application."
Case 10093: GetWinsockError = "Winsock not initialized."
Case 10101: GetWinsockError = "Disconnect."
Case 11001: GetWinsockError = "Host not found."
Case 11002: GetWinsockError = "Nonauthoritative host not found."
Case 11003: GetWinsockError = "Nonrecoverable error."
Case 11004: GetWinsockError = "Valid name, no data record of requested type."
Case Else: GetWinsockError = "Non-winsock error."
End Select
End Function

'Scan winsock stack
Private Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim S As String, mStr As String * 520, mLen As Integer, BotIndex As Byte

If uMsg = 5150 Then
 For BotIndex = 1 To LastConnectingBot 'don't scan beyond bots that aren't connecting/connected
  With Bots(BotIndex)
  If .SockID = wParam Then
   mLen = recvfrom(wParam, ByVal mStr, 520&, 0&, .Sock, 16&)
   If mLen > 0 Then
    S = Left(mStr, mLen)
    If Left(S, 2) <> Chr(0) + Chr(2) Then Decrypt BotIndex, S
'''    If Left(S, 2) <> Chr(0) + Chr(2) Then
'''     'S = Cipher(.SSEncrKey, S)
'''     If .SSEncrKey > 0 Then
''''      S = pwEncryption(S)
''''      S = Cipher(.SSEncrKey, S)
'''      If Left(S, 1) = Chr(0) Then
''''       S = Left(S, 2) + Cipher(.SSEncrKey, Mid(S, 3))
''''       S = Left(S, 2) & SHR(Mid(S, 3))
'''       S = Left(S, 2) & pwEncryption(Mid(S, 3))
'''      Else
''''       S = Left(S, 1) + Cipher(.SSEncrKey, Mid(S, 2))
''''       S = Left(S, 1) & SHR(Mid(S, 2))
'''       S = Left(S, 1) & pwEncryption(Mid(S, 2))
'''      End If
'''     End If
'''    End If
    HandlePacket BotIndex, S
    .TotalReceived = .TotalReceived + 1
    If .Users(.UserID).Ship < 8 Then 'This is where the FlyBot flies.
     If .SpawnConnected Then 'this will make it a little less laggy if a bot is not in ship
      If GetTickCount - .FlyResponse >= .LastFlyResponse Then 'ditto
       .LastFlyResponse = GetTickCount
       If .MyDir <> -1 Then
        .Dir = .Users(.MyDir).D
       ElseIf .Fly Then
        If Rnd * 80 < 2 Then .Dir = Rnd * 39 '40 (0-39) is how many times ships turns the smallest bit to complete full circle
       End If
       If .Follow <> -1 Then 'following someone
        If .Fly Then 'and auto-flying... so fly around a player
         If Rnd * 80 < 2 Then .XSpeed = -.SpeedMax + .SpeedMax * 2 * Rnd
         If Rnd * 80 < 2 Then .YSpeed = -.SpeedMax + .SpeedMax * 2 * Rnd
         .X = .X + .XSpeed
         .Y = .Y + .YSpeed
         If .X < .Users(.Follow).X - .FlyRadius Then .X = .Users(.Follow).X - .FlyRadius: If .X < 17 Then .X = 17
         If .Y < .Users(.Follow).Y - .FlyRadius Then .Y = .Users(.Follow).Y - .FlyRadius: If .Y < 17 Then .Y = 17
         If .X > .Users(.Follow).X + .FlyRadius Then .X = .Users(.Follow).X + .FlyRadius
         If .Y > .Users(.Follow).Y + .FlyRadius Then .Y = .Users(.Follow).Y + .FlyRadius
        Else
         .X = .Users(.Follow).X
         .Y = .Users(.Follow).Y
        End If
       ElseIf .Fly Then
        If Rnd * 80 < 2 Then .XSpeed = -.SpeedMax + .SpeedMax * 2 * Rnd
        If Rnd * 80 < 2 Then .YSpeed = -.SpeedMax + .SpeedMax * 2 * Rnd
        .X = .X + .XSpeed
        .Y = .Y + .YSpeed
        If .X < .FlyCenterX - .FlyRadius Then .X = .FlyCenterX - .FlyRadius: If .X < 17 Then .X = 17
        If .Y < .FlyCenterY - .FlyRadius Then .Y = .FlyCenterY - .FlyRadius: If .Y < 17 Then .Y = 17
        If .X > .FlyCenterX + .FlyRadius Then .X = .FlyCenterX + .FlyRadius
        If .Y > .FlyCenterY + .FlyRadius Then .Y = .FlyCenterY + .FlyRadius
       End If
       SendPosition BotIndex, .X, 0, .Y, 0, .Dir, 100, .Fire, 0, 0
      End If
     End If
    End If
   End If
   Exit Function
  End If
  End With
 Next
Else
 WindowProc = CallWindowProcA(OldWinsockWindow, hwnd, uMsg, wParam, ByVal lParam)
End If
End Function
